bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [PATCH] ls: make possible to stop file capabilities checking


From: Jim Meyering
Subject: Re: [PATCH] ls: make possible to stop file capabilities checking
Date: Tue, 21 Oct 2008 13:13:36 +0200

Kamil Dudka <address@hidden> wrote:
> Colorizing file with capabilities has some performance impact (rhbz #467508).
> It should be possible to stop checking for file capabilities by unsetting ca
> attribute of $LS_COLORS. One-line patch solving this issue is attached.
>
> Simple test:
> $ strace ls --color 2> tmp && grep -i cap tmp --color
>
> $ eval `dircolors -b | sed s/ca=[^:]*:/ca=:/` # disable checking for file caps
> $ strace ls --color 2> tmp && grep -i cap tmp --color

Thank you!
I adjusted the log message and applied your change,
then added the following test:

>From 028e12ce3bea55b791cf339d2b12834e5091a5e5 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Tue, 21 Oct 2008 13:09:13 +0200
Subject: [PATCH] tests: test today's ls-vs-capability fix

Test for this fix: f3f1ccfd871ee395e7fafc051c1b7dedb39fdfc9.
* tests/Makefile.am (TESTS): Add ls/no-cap.
* tests/ls/no-cap: New file.
---
 tests/Makefile.am |    1 +
 tests/ls/no-cap   |   37 +++++++++++++++++++++++++++++++++++++
 2 files changed, 38 insertions(+), 0 deletions(-)
 create mode 100755 tests/ls/no-cap

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 7a523a5..d73ce32 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -327,6 +327,7 @@ TESTS =                                             \
   ls/inode                                     \
   ls/m-option                                  \
   ls/no-arg                                    \
+  ls/no-cap                                    \
   ls/proc-selinux-segfault                     \
   ls/recursive                                 \
   ls/rt-1                                      \
diff --git a/tests/ls/no-cap b/tests/ls/no-cap
new file mode 100755
index 0000000..1cae69f
--- /dev/null
+++ b/tests/ls/no-cap
@@ -0,0 +1,37 @@
+#!/bin/sh
+# ensure that an empty "ca=" attribute disables ls's capability-checking
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  ls --version
+fi
+
+. $srcdir/test-lib.sh
+require_strace_ capget
+
+fail=0
+strace -e capget ls --color=always > /dev/null 2> out || fail=1
+$EGREP 'capget\(' out || skip_test_ "your ls doesn't call capget"
+
+rm -f out
+eval "$(TERM=xterm dircolors -b | sed 's/ca=[^:]*:/ca=:/' | tee /t/k-env)"
+strace -e capget ls --color=always > /dev/null 2> out || fail=1
+
+$EGREP 'capget\(' out && fail=1
+
+Exit $fail
--
1.6.0.2.588.g3102




reply via email to

[Prev in Thread] Current Thread [Next in Thread]